# coding: utf-8

"""
    Compass API

    <h3>With this API you can:</h3> <ul> <li><strong>Execute complex DeFi transactions:&nbsp; </strong>Swap, lend, borrow, stake, LP, and more, with high-level on-chain actions.</li> <li><strong>Stay secure &amp; non-custodial</strong> &ndash; Transactions are signed locally, and you retain full control.</li> <li><strong>Build AI &amp; automation workflows</strong> &ndash; Power AI agents, trading bots, yield products and DeFi applications with programmatic transaction execution. Integrate seamlessly into existing workflows.</li> <li><strong>Interact across multiple protocols &amp; chains</strong>&nbsp;&ndash; Spot, lending, staking on Ethereum, Arbitrum, Base. Many more to come!</li> </ul>  <h3 id=\"quick-links\" class=\"docs-chapter-header\"><a class=\"not-prose group hover:text-compass-pink transition-colors flex w-fit\" href=\"https://www.compasslabs.ai/api-docs#quick-links\">Quick links</a></h3> <ul> <li><a href=\"https://api.compasslabs.ai/\" target=\"_blank\" rel=\"noopener\">API reference</a></li> <li><a href=\"https://github.com/CompassLabs/compass_api_examples\" target=\"_blank\" rel=\"noopener\">5 min quickstart</a></li> <li><a href=\"https://discord.gg/qjP8dCYZ58\" target=\"_blank\" rel=\"noopener\">Discord</a></li> <li><a href=\"https://www.compasslabs.ai/\" target=\"_blank\" rel=\"noopener\">Compass Labs</a></li> </ul>

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from setuptools import setup, find_packages  # noqa: H301

# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools
NAME = "compass.api_client"
VERSION = "1.0.78"
PYTHON_REQUIRES = ">= 3.8"
REQUIRES = [
    "urllib3 >= 1.25.3, < 3.0.0",
    "python-dateutil >= 2.8.2",
    "pydantic >= 2",
    "typing-extensions >= 4.7.1",
]

setup(
    name=NAME,
    version=VERSION,
    description="Compass API",
    author="OpenAPI Generator community",
    author_email="team@openapitools.org",
    url="",
    keywords=["OpenAPI", "OpenAPI-Generator", "Compass API"],
    install_requires=REQUIRES,
    packages=find_packages(exclude=["test", "tests"]),
    include_package_data=True,
    long_description_content_type='text/markdown',
    long_description="""\
    &lt;h3&gt;With this API you can:&lt;/h3&gt; &lt;ul&gt; &lt;li&gt;&lt;strong&gt;Execute complex DeFi transactions:&amp;nbsp; &lt;/strong&gt;Swap, lend, borrow, stake, LP, and more, with high-level on-chain actions.&lt;/li&gt; &lt;li&gt;&lt;strong&gt;Stay secure &amp;amp; non-custodial&lt;/strong&gt; &amp;ndash; Transactions are signed locally, and you retain full control.&lt;/li&gt; &lt;li&gt;&lt;strong&gt;Build AI &amp;amp; automation workflows&lt;/strong&gt; &amp;ndash; Power AI agents, trading bots, yield products and DeFi applications with programmatic transaction execution. Integrate seamlessly into existing workflows.&lt;/li&gt; &lt;li&gt;&lt;strong&gt;Interact across multiple protocols &amp;amp; chains&lt;/strong&gt;&amp;nbsp;&amp;ndash; Spot, lending, staking on Ethereum, Arbitrum, Base. Many more to come!&lt;/li&gt; &lt;/ul&gt;  &lt;h3 id&#x3D;\&quot;quick-links\&quot; class&#x3D;\&quot;docs-chapter-header\&quot;&gt;&lt;a class&#x3D;\&quot;not-prose group hover:text-compass-pink transition-colors flex w-fit\&quot; href&#x3D;\&quot;https://www.compasslabs.ai/api-docs#quick-links\&quot;&gt;Quick links&lt;/a&gt;&lt;/h3&gt; &lt;ul&gt; &lt;li&gt;&lt;a href&#x3D;\&quot;https://api.compasslabs.ai/\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener\&quot;&gt;API reference&lt;/a&gt;&lt;/li&gt; &lt;li&gt;&lt;a href&#x3D;\&quot;https://github.com/CompassLabs/compass_api_examples\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener\&quot;&gt;5 min quickstart&lt;/a&gt;&lt;/li&gt; &lt;li&gt;&lt;a href&#x3D;\&quot;https://discord.gg/qjP8dCYZ58\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener\&quot;&gt;Discord&lt;/a&gt;&lt;/li&gt; &lt;li&gt;&lt;a href&#x3D;\&quot;https://www.compasslabs.ai/\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener\&quot;&gt;Compass Labs&lt;/a&gt;&lt;/li&gt; &lt;/ul&gt;
    """,  # noqa: E501
    package_data={"compass.api_client": ["py.typed"]},
)